SystemOrganization addCategory: #'KwisatzHaderach-StackListener'!
SystemOrganization addCategory: #KwisatzHaderach!
SystemOrganization addCategory: #'KwisatzHaderach-Tests'!

Object subclass: #CommonExpressions
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'KwisatzHaderach-Tests'!

!CommonExpressions class methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 6/9/2012 13:10'!
chainMessage
	^self otherChainMessage.! !

!CommonExpressions class methodsFor: 'arithmetic' stamp: 'SantiagoBragagnolo 6/5/2012 23:14'!
commonAdd
	| a b |
	a:= 1.
	b:=2.
	a := a + b.
	^a ! !

!CommonExpressions class methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 6/9/2012 13:10'!
otherChainMessage
	^self otherOtherChainMessage.! !

!CommonExpressions class methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 6/9/2012 13:10'!
otherOtherChainMessage
	^1.! !

Object subclass: #KHClass
	instanceVariableNames: 'representedClass possibleInstances'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'KwisatzHaderach'!

!KHClass class methodsFor: 'constructor' stamp: 'SantiagoBragagnolo 6/7/2012 21:34'!
for: aClass
	| instance | 
	instance := self new.
	instance useClass: aClass.
	^instance.
	! !

!KHClass methodsFor: 'initializing' stamp: 'SantiagoBragagnolo 6/9/2012 12:29'!
initialize 	
	super initialize.
	possibleInstances  := Dictionary new.! !

!KHClass methodsFor: 'accessing' stamp: 'SantiagoBragagnolo 6/7/2012 21:56'!
representationOf: anObjectType 
	^possibleInstances at: anObjectType ifAbsentPut: [ KHClassConfiguration for: anObjectType of: self].! !

!KHClass methodsFor: 'accessing' stamp: 'SantiagoBragagnolo 6/7/2012 21:34'!
useClass: aClass
	representedClass := aClass
	! !

Object subclass: #KHClassConfiguration
	instanceVariableNames: 'configuration instanceOf selectors'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'KwisatzHaderach'!

!KHClassConfiguration class methodsFor: 'constructor' stamp: 'SantiagoBragagnolo 6/7/2012 21:39'!
for: anObjectType of: aKHClass
	| instance |
	instance := self new.
	instance configuration: anObjectType.
	instance instanceOf: aKHClass.
	^ instance.! !

!KHClassConfiguration methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 6/9/2012 12:49'!
atSelectorComposedBy:anOriginSelector withArguments: anOriginalSelectorArgumentsArray.

	^selectors 	at: (KHSelector makeUniqueIdentifier: anOriginSelector withArguments: anOriginalSelectorArgumentsArray at: self) 
				ifAbsentPut: [ KHSelector for: anOriginSelector withArguments: anOriginalSelectorArgumentsArray at: self ]. ! !

!KHClassConfiguration methodsFor: 'accessing' stamp: 'SantiagoBragagnolo 6/7/2012 21:38'!
configuration: anObjectType 
	configuration := anObjectType.! !

!KHClassConfiguration methodsFor: 'accessing' stamp: 'SantiagoBragagnolo 6/9/2012 12:51'!
hash
	^configuration hash.! !

!KHClassConfiguration methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 6/9/2012 12:32'!
initialize 
	super initialize.
	selectors  := Dictionary new.
	! !

!KHClassConfiguration methodsFor: 'accessing' stamp: 'SantiagoBragagnolo 6/7/2012 21:38'!
instanceOf: aKHClass 
	instanceOf := aKHClass.! !

Object subclass: #KHSelector
	instanceVariableNames: 'uid selector arguments owner callsIn callsOut'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'KwisatzHaderach'!

!KHSelector class methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 6/9/2012 12:50'!
for: aSelector withArguments: anArgumentsArray at: aKHClassConfiguration 
	| instance | 
	instance := self new.
	instance uid: (self makeUniqueIdentifier: aSelector withArguments: anArgumentsArray at: aKHClassConfiguration  ).
	instance selector: aSelector.
	instance arguments: anArgumentsArray.
	instance owner: aKHClassConfiguration.
	^instance.! !

!KHSelector class methodsFor: 'auxiliar' stamp: 'SantiagoBragagnolo 6/9/2012 12:50'!
makeUniqueIdentifier: anOriginSelector withArguments: anOriginalSelectorArgumentsArray at: aKHClassConfiguration

	| uq arguments |
	
	arguments := '' join: (anOriginalSelectorArgumentsArray collect: [ :t | t hash asString ]).
	uq := aKHClassConfiguration hash asString, anOriginSelector, arguments.
	
	^uq.! !

!KHSelector methodsFor: 'accessing' stamp: 'SantiagoBragagnolo 6/7/2012 21:57'!
arguments: anArgumentsArray.
	arguments := anArgumentsArray.! !

!KHSelector methodsFor: 'calls' stamp: 'SantiagoBragagnolo 6/7/2012 22:01'!
callsTo: methodCalled
	self registerCallTo: methodCalled.
	methodCalled registerCalledBy: self.
	! !

!KHSelector methodsFor: 'initializing' stamp: 'SantiagoBragagnolo 6/7/2012 21:58'!
initialize 
	callsIn := OrderedCollection new. 
	callsOut := OrderedCollection new.
	! !

!KHSelector methodsFor: 'accessing' stamp: 'SantiagoBragagnolo 6/7/2012 21:57'!
owner: aConfiguration
	owner := aConfiguration.! !

!KHSelector methodsFor: 'private tier' stamp: 'SantiagoBragagnolo 6/7/2012 21:59'!
registerCallTo: aTargetCall
	callsOut add: aTargetCall.
	
	! !

!KHSelector methodsFor: 'private tier' stamp: 'SantiagoBragagnolo 6/7/2012 22:00'!
registerCalledBy: asTargetedBy
	callsIn add: asTargetedBy.
	
	! !

!KHSelector methodsFor: 'accessing' stamp: 'SantiagoBragagnolo 6/7/2012 21:57'!
selector: aSelector.
	selector := aSelector.! !

!KHSelector methodsFor: 'accessing' stamp: 'SantiagoBragagnolo 6/7/2012 21:56'!
uid: anUid
	uid := anUid.
! !

Object subclass: #KwisatzHaderach
	instanceVariableNames: 'result stackListener rootSender classes'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'KwisatzHaderach'!

!KwisatzHaderach class methodsFor: 'constructor' stamp: 'SantiagoBragagnolo 6/9/2012 11:54'!
callgraphFor: anExpression
	| instance | 
	instance := self new.
	^instance callgraphFor: anExpression
	! !

!KwisatzHaderach methodsFor: 'callgraph' stamp: 'SantiagoBragagnolo 6/5/2012 23:17'!
callgraphFor: anExpression
	result := Compiler new analyze: anExpression  in:  nil to: nil notifying: nil ifFail:[ :fail | self manage: fail].
	^ self.! !

!KwisatzHaderach methodsFor: 'initialize' stamp: 'SantiagoBragagnolo 6/9/2012 12:32'!
initialize 
	super initialize.
	TiPrimitive initialize.
	TiSystem current reset.
	stackListener := StackListener for: self.
	classes := Dictionary new.
	self registerToStackAnnouncements.
	
! !

!KwisatzHaderach methodsFor: 'callgraph' stamp: 'SantiagoBragagnolo 6/9/2012 11:23'!
makeRootMethodSender
	^self makeRootSender atSelectorComposedBy: 'rootMessage' withArguments: #().
! !

!KwisatzHaderach methodsFor: 'callgraph' stamp: 'SantiagoBragagnolo 6/9/2012 12:49'!
makeRootSender
	rootSender ifNil: [ rootSender := self representationOf: (UndefinedObject concreteType )].
	^rootSender

	
! !

!KwisatzHaderach methodsFor: 'error' stamp: 'SantiagoBragagnolo 6/5/2012 22:46'!
manage: fail
	self error: fail.! !

!KwisatzHaderach methodsFor: 'callgraph' stamp: 'SantiagoBragagnolo 6/9/2012 12:27'!
register: aSelector withArguments: anArgumentsArray sentTo: aReceptorObjectType  from: anOriginSelector withArguments: anOriginalSelectorArgumentsArray atSender: aSenderObjectType
	| objectSender objectReceptor methodSender methodCalled senderArgumentsArray | 

	(aSenderObjectType = nil) ifFalse:[
		objectSender  := self representationOf: aSenderObjectType.
		methodSender := objectSender atSelectorComposedBy:anOriginSelector withArguments: anOriginalSelectorArgumentsArray.
	] ifTrue: [
		objectSender := self makeRootSender.
		methodSender := self makeRootMethodSender.
	].
	
	objectReceptor  := self representationOf: aReceptorObjectType.
	methodCalled := objectReceptor atSelectorComposedBy: aSelector withArguments: anArgumentsArray.
	
	methodSender callsTo: methodCalled.! !

!KwisatzHaderach methodsFor: 'initialize' stamp: 'SantiagoBragagnolo 6/9/2012 12:24'!
registerToStackAnnouncements
	TiSystem current interpreter subscribe: StackPoped send:#announcePop: to: self stackListener.
	TiSystem current interpreter subscribe: StackPushed send:#announcePush: to: self stackListener.! !

!KwisatzHaderach methodsFor: 'accessing' stamp: 'SantiagoBragagnolo 6/7/2012 21:32'!
representationOf: anObjectType 
	| class |
	class := self representationOfClass: anObjectType exactClass.
	^class representationOf: anObjectType ! !

!KwisatzHaderach methodsFor: 'accessing' stamp: 'SantiagoBragagnolo 6/9/2012 12:32'!
representationOfClass: aClass
	^classes at: aClass  ifAbsentPut: [ KHClass for: aClass ].! !

!KwisatzHaderach methodsFor: 'accessing' stamp: 'SantiagoBragagnolo 6/5/2012 23:15'!
stackListener 
	^stackListener ! !

!KwisatzHaderach methodsFor: 'accessing' stamp: 'SantiagoBragagnolo 6/5/2012 23:15'!
stackListener: aListener
	stackListener := aListener.! !

Object subclass: #KwisatzHaderachWorkspace
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'KwisatzHaderach-Tests'!

!KwisatzHaderachWorkspace methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 6/9/2012 13:11'!
callgraphChainMessage
" self new callgraphChainMessage "
	^KwisatzHaderach callgraphFor: 'CommonExpressions chainMessage'.! !

!KwisatzHaderachWorkspace methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 6/9/2012 11:24'!
callgraphCommonAdd
" self new callgraphCommonAdd "
	^KwisatzHaderach callgraphFor: 'CommonExpressions commonAdd'.! !

Object subclass: #StackListener
	uses: TLogger
	instanceVariableNames: 'classMap selectorMap methodMap owner'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'KwisatzHaderach-StackListener'!

StackListener class
	uses: TLogger classTrait
	instanceVariableNames: ''!

!StackListener class methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 6/5/2012 23:18'!
for: aKwisatzHaderach 
	| instance | 
	instance := self new.
	instance owner: aKwisatzHaderach.
	^instance. ! !

!StackListener methodsFor: 'announcement' stamp: 'SantiagoBragagnolo 6/9/2012 12:26'!
announcePop: aStackPoped 
	self info:[ 'pop announced' ].! !

!StackListener methodsFor: 'announcement' stamp: 'SantiagoBragagnolo 6/9/2012 12:27'!
announcePush: aStackPushed
| anObjectType|
	anObjectType := aStackPushed receptor veryDeepCopyWithContext: ContextualDeepCopier kwisatzHaderach.
	self info:[ 'push announced' ].
	owner 	register: aStackPushed selector 
			withArguments: aStackPushed arguments 
			sentTo: anObjectType 
			from:aStackPushed senderSelector 
			withArguments: aStackPushed senderArguments  
			atSender: aStackPushed sender.
! !

!StackListener methodsFor: 'initialize' stamp: 'SantiagoBragagnolo 6/5/2012 22:23'!
initialize
	classMap := Dictionary new.
	selectorMap := Dictionary new.
	methodMap := Dictionary new.! !

!StackListener methodsFor: 'accessing' stamp: 'SantiagoBragagnolo 6/5/2012 23:19'!
owner
 	^owner! !

!StackListener methodsFor: 'accessing' stamp: 'SantiagoBragagnolo 6/5/2012 23:19'!
owner: aKwisatzHaderach 	
 	owner := aKwisatzHaderach.! !
